-- get the addon namespace
local addon, ns = ...

-- get the config values
local cfg = ns.cfg

-- get the library
local lib = ns.lib

lib.classes["DRUID"] = {}
local t,s
lib.classes["DRUID"][1] = function()
	lib.AddSpell("Wrath",{5176}) -- Wrath
	cfg.gcd = "Wrath"
	lib.AddSpell("Starfire",{2912}) -- Starfire
	lib.AddSpell("Moonfire",{8921}) -- Moonfire
	lib.AddSpell("Starsurge",{78674}) -- Starsurge
	lib.AddSpell("IS",{5570}) -- Insect Swarm
	lib.AddSpell("Inner",{29166}) -- Innervate
	
	lib.AddAura("Moonfire",8921,"debuff","target") -- Moonfire
	lib.AddAura("Sunfire",93402,"debuff","target") -- Sunfire
	lib.AddAura("IS",5570,"debuff","target") -- Moonfire
	lib.AddAura("Solar",48517,"buff","player") -- Solar
	lib.AddAura("SS",93400,"buff","player") -- Shooting Stars
	lib.AddAura("Lunar",48518,"buff","player") -- Lunar
	
	cfg.plistdps = {}
	table.insert(cfg.plistdps,"Starsurge_SS")
	table.insert(cfg.plistdps,"IS_noIS")
	table.insert(cfg.plistdps,"Moonfire_noMoonfire")
	table.insert(cfg.plistdps,"Starsurge")
	table.insert(cfg.plistdps,"Starfire")
	table.insert(cfg.plistdps,"Wrath")
	table.insert(cfg.plistdps,"Inner")
	table.insert(cfg.plistdps,"end")
	cfg.plist=cfg.plistdps
	
	cfg.case = {
		["Moonfire_noMoonfire"] = function ()
			if lib.GetAura({"Moonfire","Sunfire"})-lib.GetSpellCD(cfg.gcd)<2 then
				return lib.SimpleCDCheck("Moonfire")
			end
			return nil
		end,
		["IS_noIS"] = function ()
			if lib.GetAura({"IS"})-lib.GetSpellCD(cfg.gcd)<2 then
				return lib.SimpleCDCheck("IS")
			end
			return nil
		end,
		["Starsurge"] = function ()
			if not lib.SpellCasting("Starsurge") or lib.GetAura({"SS"})>0 then
				return lib.SimpleCDCheck("Starsurge")
			end
			return nil
		end,
		["Starsurge_SS"] = function ()
			if lib.GetAura({"SS"})>0 then
				return lib.SimpleCDCheck("Starsurge")
			end
			return nil
		end,
		["Wrath"] = function ()
			if lib.GetAura({"Solar"})>0 then 
				return lib.SimpleCDCheck("Wrath")
			elseif lib.GetAura({"Lunar"})==0 and cfg.eclipse<=0 then
				if cfg.eclipse>-85 then
					return lib.SimpleCDCheck("Wrath")
				elseif cfg.eclipse<=-85 and lib.SpellCasting("Starsurge") then
					return lib.SimpleCDCheck("Starfire")
				elseif cfg.eclipse<=-87 and lib.SpellCasting("Wrath") then
					return lib.SimpleCDCheck("Starfire")
				end
				return lib.SimpleCDCheck("Wrath")
			end
			return nil
		end,
		["Starfire"] = function ()
			if lib.GetAura({"Lunar"})>0 then
				return lib.SimpleCDCheck("Starfire")
			elseif lib.GetAura({"Solar"})==0 and cfg.eclipse>0 then
				if cfg.eclipse<80 then
					return lib.SimpleCDCheck("Starfire")
				elseif cfg.eclipse>=80 and lib.SpellCasting("Starfire") then
					return lib.SimpleCDCheck("Wrath")
				elseif cfg.eclipse>=85 and lib.SpellCasting("Starsurge") then
					return lib.SimpleCDCheck("Wrath")
				end
				return lib.SimpleCDCheck("Starfire")
			end
			return nil
		end,
	}
	
	lib.rangecheck=function()
		if lib.inrange("Wrath") then
			lib.bdcolor(Heddframe.bd,nil)
		else
			lib.bdcolor(Heddframe.bd,{1,0,0,1})
		end
	end
	
	cfg.eclipse=UnitPower('player', SPELL_POWER_ECLIPSE)
	function Heddevents:UNIT_POWER(unit,powerType)
		if unit=="player" and powerType == 'ECLIPSE' then
			cfg.eclipse=UnitPower('player', SPELL_POWER_ECLIPSE)
			cfg.Update=true
		end
	end

	cfg.onpower=true
	cfg.spellcaster=true
	return true
end

lib.classes["DRUID"][2] = function()
	lib.AddSpell("Wrath",{5176}) -- Wrath
	cfg.gcd = "Wrath"
	lib.AddSpell("Enrage",{5229}) -- Enrage
	lib.AddSpell("Mangle",{33878}) -- Mangle
	lib.AddSpell("FF",{16857}) -- Faerie Fire (Feral)
	lib.AddSpell("Maul",{6807}) -- Maul
	lib.AddSpell("Swipe",{779}) -- Swipe
	lib.AddSpell("Demo",{99}) -- Demoralizing Roar
	lib.AddSpell("Lacerate",{33745}) -- Lacerate
	lib.AddSpell("Pulverize",{80313}) -- Pulverize
	
	lib.AddAura("Mangle",33878,"debuff","target") -- Mangle
	lib.AddAura("Lacerate",33745,"debuff","target") -- Lacerate
--	lib.AddAura("FF",91565,"debuff","target") -- Faerie Fire

--[[	lib.AddAura("IS",5570,"debuff","target") -- Moonfire
	lib.AddAura("Solar",48517,"buff","player") -- Solar
	lib.AddAura("SS",93400,"buff","player") -- Shooting Stars
	lib.AddAura("Lunar",48518,"buff","player") -- Lunar]]
	
	lib.AddAura("Demo1",1160,"debuff","target","any") -- Demoralizing Shout 
	lib.AddAura("Demo2",702,"debuff","target","any") -- Curse of Weakness
	lib.AddAura("Demo3",99,"debuff","target","any") -- Demoralizing Roar
	lib.AddAura("Demo4",50256,"debuff","target","any") -- Demoralizing Roar
	lib.AddAura("Demo5",24423,"debuff","target","any") -- Demoralizing Screech
	lib.AddAura("Demo6",81130,"debuff","target","any") -- Scarlet Fever
	lib.AddAura("Demo7",26017,"debuff","target","any") -- Vindication
	
	cfg.plistdps = {}
	table.insert(cfg.plistdps,"Demo_noDemo")
	table.insert(cfg.plistdps,"Pulverize_Lacerate")
	table.insert(cfg.plistdps,"FF")
	table.insert(cfg.plistdps,"Mangle")
	table.insert(cfg.plistdps,"Lacerate")
	table.insert(cfg.plistdps,"Maul_single")
	table.insert(cfg.plistdps,"Enrage")
	table.insert(cfg.plistdps,"end")
	
	cfg.plistaoe = {}
	table.insert(cfg.plistaoe,"Demo_noDemo")
	table.insert(cfg.plistaoe,"Swipe")
	table.insert(cfg.plistaoe,"Pulverize_Lacerate")
	table.insert(cfg.plistaoe,"Mangle")
	table.insert(cfg.plistaoe,"Lacerate")
	table.insert(cfg.plistaoe,"FF")
--	table.insert(cfg.plistaoe,"Maul_aoe")
	table.insert(cfg.plistaoe,"Enrage")
	table.insert(cfg.plistaoe,"end")
	
	cfg.case = {
		["Demo_noDemo"] = function()
			if lib.GetAuras("Demo")<1 then
				return lib.SimpleCDCheck("Demo")
			end
			return nil
		end,
		["Enrage"] = function ()
			if cfg.power<30 then
				return lib.SimpleCDCheck("Enrage")
			end
			return nil
		end,
		["Maul_single"] = function ()
			if cfg.power>=90 and lib.GetSpellCD(cfg.gcd)>=1 then
				return lib.SimpleCDCheck("Maul")
			end
			return nil
		end,
		["Pulverize_Lacerate"] = function ()
			t,s=lib.GetAura({"Lacerate"})
			if s==3 then
				return lib.SimpleCDCheck("Pulverize")
			end
			return nil
		end,
		["Maul_aoe"] = function ()
			if cfg.power>=45 and lib.GetSpellCD("Swipe")>=lib.GetSpellCD(cfg.gcd) then
				return lib.SimpleCDCheck("Maul")
			end
			return nil
		end,
		
	}
	
	lib.rangecheck=function()
		if lib.inrange("Mangle") then
			lib.bdcolor(Heddframe.bd,nil)
		elseif lib.inrange("FF") then
			lib.bdcolor(Heddframe.bd,{0,0,1,1})
		else
			lib.bdcolor(Heddframe.bd,{1,0,0,1})
		end
	end
	
	cfg.plist=cfg.plistdps
	cfg.mode = "dps"
	lib.onclick = function()
		if cfg.mode == "dps" then
			cfg.mode = "aoe"
			cfg.plist=cfg.plistaoe
			cfg.Update=true
		else
			cfg.mode = "dps"
			cfg.plist=cfg.plistdps
			cfg.Update=true
		end
		
	end
	
	cfg.onpower=true
--	cfg.spellcaster=true
	return true
end
